/**
 * AsynchronousNode.java
 * Created on 2005/05/18
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.ProtocolException;

/**
 * Node̔񓯊talkׂ̈I/F
 * @author es
 */
public interface AsynchronousNode extends Node {
 
    /**
     * 񓯊talks
     * @param command R}h
     * @param argument 
     * @throws MalformedURLException
     * @throws ProtocolException
     * @throws IOException
     */
    public void asyncTalk(String command, String argument) throws MalformedURLException, ProtocolException, IOException;

    /**
     * CxgXi[ɒʒm
     * @param event m[hCxg
     */
    public void fire(TalkingEvent event);

    /**
     * Xi[ǉ.<br>
     * ̃m[h̃Cxg󂯎郊Xi[ǉ
     * @param listener 񓯊m[hXi
     */
    public void addNodeListener(AsynchronousNodeListener listener);

    /**
     * Xi폜.<br>
     * w肳ꂽXi[폜
     * @param listener 񓯊m[hXi
     */
    public void removeNodeListener(AsynchronousNodeListener listener);
    
    /**
     * ݓo^Ă郊Xi[擾
     * @return
     */
    public AsynchronousNodeListener[] getNodeListeners();

}
