package izayoi.servlet;

import izayoi.Configures;
import izayoi.Izayoi;
import izayoi.Util;
import izayoi.cache.CacheFactory;
import izayoi.node.NodeController;
import izayoi.node.NodeControllerFactory;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import javax.servlet.GenericServlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.velocity.app.Velocity;

/**
 * servlet<br>
 * Kweb.xmlload-on-startupŏʂɕtċN邱
 * @author es
 */
public class Initializer extends GenericServlet {

    /* ( Javadoc)
     * @see javax.servlet.GenericServlet#service(javax.servlet.ServletRequest, javax.servlet.ServletResponse)
     */
    public void service(ServletRequest arg0, ServletResponse arg1) throws ServletException, IOException {
        //Ȃ
    }

    /* ( Javadoc)
     * @see javax.servlet.Servlet#init(javax.servlet.ServletConfig)
     */
    public void init(ServletConfig arg0) throws ServletException {
        super.init(arg0);
        String root = getServletContext().getRealPath("./");
        Configures conf = Configures.getConfigures(new File(root, arg0.getInitParameter("config")));

        Properties p = new Properties();
        Class cls;
        try {
            p.load(new FileInputStream(new File(root, arg0.getInitParameter("velocity"))));
            Velocity.init(p);
            synchronized (this) {
                cls = Class.forName(conf.getParameter(Izayoi.CONFIG_NODE_CONTROLLER));
                NodeController node = NodeControllerFactory.getInstance(cls);
                cls = Class.forName(conf.getParameter(Izayoi.CONFIG_CACHE_FACTORY));
                CacheFactory cache = CacheFactory.createInstance(cls);

                node.registCacheFactory(cache);
                cache.registNodeController(node);
                Util.setServletContext(arg0.getServletContext());
            }
        } catch (Exception e) {
            throw new ServletException(e);
        }
    }

    /* ( Javadoc)
     * @see javax.servlet.Servlet#destroy()
     */
    public void destroy() {
        NodeController con = NodeControllerFactory.getInstance();
        if (con == null) {
            return;
        }
        try {
            con.disconnect();
        } catch (IOException e) {
            e.printStackTrace();
        }
        super.destroy();
    }

}
