package net.prixdami.alexis.multipart;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

public interface MultipartFile {
	public static final String MULTIPART_ITEMS = "Multipart_Items";

    /**
     * @return parameter name of this file that posted from HTML-form.
     */
    public String getParameterName();

    /**
     * @return file name of this file that posted from HTML-form.
     */
    public String getOriginFileName();

	/**
	 * @return stored-fileName (it is *NOT* posted file-name)
	 */
	public String getFileName();

	/**
	 * @return MIME-type.
	 */
    public String getContentType();

	/**
	 * @return File object of stored file.
	 */
    public File getFile();

	/**
	 * @return filesize
	 */
    public long getFileSize();

	/**
	 * @return InputStream object of stored file.
	 * @exception IOException
	 */
    public InputStream getInputStream() throws IOException;

}
