/*
 * NetworkCacheAgent.java
 *
 * Created on 2004/10/28, 17:27
 */

package net.sourceforge.shingetsu.cache;

import java.util.Vector;
import java.util.Enumeration;

import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.node.NodeList;

import java.io.IOException;
import java.net.ProtocolException;
import java.net.MalformedURLException;

/**
 * lbg[NLbVt@CTA܂̓Abvf[gȂǂ𑗏o
 * G[WFgNXłBׂẴR[h擾߂̏͂̃NXœߓIɍs
 * ܂B
 * @author stokesia
 */
public class NetworkCacheAgent {
    
    private NodeList nodeList = NodeList.getInstance();
    
    /** Creates a new instance of NetworkCacheAgent */
    public NetworkCacheAgent() {
    }
    
    /**
     * m[hXgŕێĂ鑼̃m[hɍXVꂽt@C邱Ƃm点܂B
     * @param updatedNode t@CXVꂽm[h
     * @param filename XVꂽt@C̖O
     * @param time XVꂽR[h̎
     * @param md5 XVꂽR[h̎ʎq
     */    
    public void informUpdate(Node updatedNode, String filename, long time, String md5){
        Enumeration enumeration = nodeList.enumeration();
        
        String timeArgument = new Long(time).toString();
        
        while(enumeration.hasMoreElements()) {
            Node node = (Node) enumeration.nextElement();
            
            try {
                node.update(filename, timeArgument, md5, updatedNode);
            } catch(MalformedURLException e) {
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
    }
    
    /**
     * getR}hpălbg[N烌R[h擾܂B
     * @param filename t@Cl[
     * @param timeArgument VvgRɏ]
     * @return 擾R[hStringzA擾łȂnull
     */    
    public String[] getRecordsWithGET(String filename, String timeArgument) {
        Enumeration enumeration = nodeList.enumeration();
        
        String[] maxRecords = null;
        
        while(enumeration.hasMoreElements()) {
            Node node = (Node) enumeration.nextElement();
            
            try {
                String[] records = node.get(filename, timeArgument);
                
                if(records != null) {
                    if(maxRecords == null) {
                        maxRecords = records;
                    }
                    
                    if(records.length > maxRecords.length) {
                        maxRecords = records;
                    }
                }
            } catch(MalformedURLException e) {
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
        return maxRecords;
    }
    
    /**
     * headR}hpălbg[N烌R[h擾܂B
     * @param filename t@Cl[
     * @param timeArgument VvgRɏ]
     * @return 擾R[hStringzA擾łȂnull
     */    
    public String[] getRecordsWithHEAD(String filename, String timeArgument) {
        Enumeration enumeration = nodeList.enumeration();
        
        String[] maxRecords = null;
        
        while(enumeration.hasMoreElements()) {
            Node node = (Node) enumeration.nextElement();
            
            try {
                String[] records = node.head(filename, timeArgument);
                
                if((records != null) && (records.length != 0)) {
                    if(maxRecords == null) {
                        maxRecords = records;
                    }
                    
                    if(records.length > maxRecords.length) {
                        maxRecords = records;
                    }
                }
            } catch(MalformedURLException e) {
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
        return maxRecords;
    }
    
    /**
     * getR}hpălbg[N烌R[h擾܂B
     * @param filename t@Cl[
     * @param time ^CX^v
     * @param id ʎq
     * @return 擾R[hStringzA擾łȂnull
     */    
    public String getRecord(String filename, long time, String id) {
        Enumeration enumeration = nodeList.enumeration();
        
        String[] maxRecords = null;
        
        String timeStamp = Long.toString(time);
        
        String timeArgument = timeStamp + "/" + id;
        
        while(enumeration.hasMoreElements()) {
            Node node = (Node) enumeration.nextElement();
            
            try {
                String[] records = node.get(filename, timeArgument);
                
                if((records != null) && (records.length != 0)) {
                    if(maxRecords == null) {
                        maxRecords = records;
                    }
                    
                    if(records.length > maxRecords.length) {
                        maxRecords = records;
                    }
                }
            } catch(MalformedURLException e) {
                System.err.println("m[hAhXsłB");
                e.printStackTrace();
            } catch(ProtocolException e) {
                System.err.println("X|XbZ[WsłB");
                e.printStackTrace();
            } catch(IOException e) {
                System.err.println("o͒ɃG[܂B");
                e.printStackTrace();
            }
        }
        
        String record = null;
        
        if(maxRecords != null) {
            record = maxRecords[0];
        }
        
        return record;
    }

}
