/*
 * Server.java
 *
 * Created on 2004/07/18, 13:28
 */

package net.sourceforge.shingetsu.server;

import java.lang.Thread;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Hashtable;
import java.util.LinkedList;

import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.server.cgi.ContentCGI;

import java.io.IOException;
import java.lang.SecurityException;
import java.lang.IllegalThreadStateException;
import java.net.SocketTimeoutException;
import java.nio.channels.IllegalBlockingModeException;

/**
 * @̃NX͐ṼT[ő@\񋟂NXłBT[o̓NGXg
 * ƃXbh(f[Xbh)𐶐āAXbhɏC܂BNGX
 * g͓K؂HttpRequestNX̃IuWFNgƂăJvZANGXgɉ
 * ăXbh͓K؂CGIsX|Xs܂B
 * @author Fuktommy
 * @author stokesia
 */
public class HttpServer {
    
    public static final String METHOD_GET ="GET";
    public static final String METHOD_POST ="POST";
    
    public static final String HTTP_VERSION_0_9 = "HTTP/0.9";
    public static final String HTTP_VERSION_1_0 = "HTTP/1.0";
    public static final String HTTP_VERSION_1_1 = "HTTP/1.1";
    
    public static final String CGI_VERSION = "CGI/1.0";
    
    public static final String SUPPORTED_HTTP_VERSION = HTTP_VERSION_1_0;
    public static final String SUPPORTED_CGI_VERSION = CGI_VERSION;
    
    public static final String LINE_FEED_CRLF = "\r\n";
    public static final String LINE_FEED_LF = "\n";
    
    public static final int OK = 200;
    public static final int CREATED = 201;
    public static final int NOT_CONTENT = 204;
    
    public static final int MOVE_PERMANENTLY = 301;
    public static final int FOUND = 302;
    //public static final int SEE_OTHER = 303;

    public static final int BAD_REQUEST = 400;
    public static final int NOT_FOUND = 404;
    
    public static final int INTERNAL_SERVER_ERROR = 500;
    
    public static final String CONTENT_CGI_KEY = "ContentCGI/";
  
    private Config config = Config.getInstance();
   
    private LinkedList serverThreadList = null;
    private int startServerThread = config.getStartServerThread();
    private int maxServerThread = config.getMaxServerThread();
    private long HANDLING_WAIT_TIME = 500L;
    
    private static Hashtable reasonPhraseTable = null;

    /** Creates a new instance of Server */
    public HttpServer() {
        serverThreadList = new LinkedList();
        
        for(int i = 0; i < startServerThread; i++) {
            serverThreadList.add(new HttpServerThread());
        }
        
    }
    
    /**
     * @̃\bh̓T[oX^[g܂B
     */
    public void start() {
        ServerSocket serverSocket = null;
        
        try {
            serverSocket = new ServerSocket(config.getPort(), config.getBacklog());
        } catch(IOException e) {
            printErrorMessage(e, "\PbgJĂƂɓo̓G[܂B");
            return;
        } catch(SecurityException e) {
            printErrorMessage(e, "ZLeB}l[W checkListen \bh̑܂B");
            return;
        }
        
        Socket socket = null;
        
        while(true) {
            try {
                socket = serverSocket.accept();
            } catch(SocketTimeoutException e) {
                printErrorMessage(e, "\Pbg^CAEg܂B");
                break;
            } catch(IOException e) {
                printErrorMessage(e, "ڑ̑ҋ@ɓo̓G[܂B");
                break;
            } catch(SecurityException e) {
                printErrorMessage(e, "ZLeB}l[W checkListen \bh̑܂B");
                break;
            } catch(IllegalBlockingModeException e) {
                printErrorMessage(e, "ubLO[hŁA\PbgɊ֘A`l݂܂B");
                break;
            }
            
            HttpServerThread serverThread =  getServerThread();
            
            assert !serverThread.isHandling();
            
            if(!socket.isClosed()) {
                try {
                    serverThread.setSocket(socket);
                } catch(IllegalStateException e) {
                    printErrorMessage(e, "\Pbg̃nhOłB");
                    continue;
                } catch(NullPointerException e) {
                    printErrorMessage(e, "\PbgnullłB");
                    continue;
                }
                
                try {
                    serverThread.start();
                    serverThreadList.addLast(serverThread);
                    //HttpServerThread httpServerThread = new HttpServerThread(socket);
                    //httpServerThread.run();
                } catch(IllegalThreadStateException e) {
                    printErrorMessage(e, "XbhłɋNĂ܂B");
                    serverThread.setHandling(false);
                 } catch(IllegalStateException e) {
                  printErrorMessage(e, "\Pbg̃nhOłB");
                  serverThread.setHandling(false);
                }
            }

        }
    }
    
    private HttpServerThread getServerThread() {
        HttpServerThread serverThread = null;
        
        while(true) {
            for(int i = 0; i < serverThreadList.size(); i++) {
                serverThread = (HttpServerThread) serverThreadList.removeFirst();
                
                if(!serverThread.isHandling()) {
                    break;
                }
                
                serverThreadList.addLast(serverThread);
            }
            
            if(serverThreadList.size() < maxServerThread) {
                serverThread = new HttpServerThread();
                break;
            }
            
            try {
                Thread.sleep(HANDLING_WAIT_TIME);
            } catch(InterruptedException e) {
                printErrorMessage(e, "荞݂܂B");
            }
        }
        
        return serverThread;
    }

    private void printErrorMessage(Exception exception, String message) {
        System.out.println(message);
        exception.printStackTrace();
    }
    
    public static String getReasonPhrase(int statusCode) {
        if(reasonPhraseTable == null) {
            reasonPhraseTable = new Hashtable();
            
            reasonPhraseTable.put(new Integer(OK), "OK");
            reasonPhraseTable.put(new Integer(NOT_CONTENT), "Not Content");
            
            //reasonPhraseTable.put(new Integer(SEE_OTHER), "See Other");
        
            reasonPhraseTable.put(new Integer(BAD_REQUEST), "Bad Request");
            reasonPhraseTable.put(new Integer(NOT_FOUND), "Not Found");
            
            reasonPhraseTable.put(new Integer(INTERNAL_SERVER_ERROR), "Internal Server Error");
        }
        
        Integer key = new Integer(statusCode);
        String message = null;
        
        if(reasonPhraseTable.containsKey(key)) {
            message =  (String) reasonPhraseTable.get(key);
        }
    
        return message;
    }
    
    
}
