/*
 * HttpServerThread.java
 *
 * Created on 2004/08/16, 22:20
 */

package net.sourceforge.shingetsu.server;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.Runnable;
import java.net.InetAddress;
import java.net.Socket;
import java.nio.charset.CharsetDecoder;
import java.nio.charset.Charset;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Date;

import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.HttpRequestProcessor;
import net.sourceforge.shingetsu.server.HttpResponseProcessor;
import net.sourceforge.shingetsu.server.HttpProtocolException;
import net.sourceforge.shingetsu.server.cgi.CGI;
import net.sourceforge.shingetsu.server.cgi.ErrorCGI;

import java.io.IOException;

/**
 * @̃NXHttpServerNX̃XbhƂē삵܂BXbhA
 * XbhsƃNGXgǂݍrequestNX̃IuWFNg
 * AK؂CGIvOsăX|XԂ܂B
 * @author Fuktommy
 * @author stokesia
 */
public class HttpServerThread extends Thread {

    private Config config = Config.getInstance();
    
    private Socket socket = null;
    private InputStream inputStream = null;
    private OutputStream outputStream = null;
    private long date = 0;
    
    private volatile Boolean handling = null;
    
    private String server = config.getUserAgent();
    
    /**
     * ̃NX̃CX^X𐶐܂B
     */    
    public HttpServerThread() {
        handling = new Boolean(false);
    }
    
    protected HttpServerThread(Socket socket) {
        this.socket = socket;
    }
    
    /**
     * nhO\PbgZbg܂BʏisHandling()\bhł̃Xb
     * hnhOm߂ĂÃ\bhs܂B
     * @param socket ڑĂNCAg̃\Pbg
     * @throws NullPointerException \Pbgnull̏ꍇ
     * @throws IllegalStateException \PbgnhȌꍇ
     */
    public void setSocket(Socket socket) 
        throws NullPointerException, IllegalStateException {
        synchronized(handling) {
            if(handling.booleanValue()) {
                throw new IllegalStateException("̃Xbh̃\Pbg͌݃nhOłB");
            }
        }
        
        assert (handling.booleanValue() == false);
        
        if(socket == null) {
            throw new NullPointerException("w肳ꂽ\PbgnullłB");
        }
        
        this.socket = socket;
    }

    /**
     * ̃Xbh݃\PbgnhOǂԂ܂B
     * @return nhOȂtrue
     */    
    public synchronized boolean isHandling() {
        return handling.booleanValue();
    }
    
    /**
     * ̃Xbh̃nhOXe[^XZbg܂BnhOȂtrue
     * Zbg܂BʏÃ\bh͗O̗\ʃG[\bh̐
     * Ăяoɖ߂ꍇɈӐ}IɃXe[^XύX邽߂ɗp܂B
     * @param value nhOȂtrue
     */    
    public synchronized void setHandling(boolean value) {
        handling = new Boolean(value);
        
        if(!handling.booleanValue()) {
            socket = null;
        }
    }
    
    /**
     * T[õXbhX^[g܂B
     * @throws IllegalStateException \Pbg̃nhOɂ̃XbhsꍇA
     * ܂̓\PbgZbgĂȂꍇ
     */
    public void run() throws IllegalStateException {
        if(isHandling()){
            throw new IllegalStateException("̃Xbh͌݃nhOłB");
        }

        if(socket == null) {
            throw new IllegalStateException("\PbgZbgĂ܂B");
        }
        
        setHandling(true);

        assert socket != null;
        
        date = new Date().getTime();
        
    	HttpRequest request = null;
        HttpResponse response = null;
        
        try {
            response = createResponse(socket);
            request = readRequest(socket);
        } catch(HttpProtocolException e) {
            excecuteErrorCGI(request, response, e); 
            setHandling(false);
            return;
        } catch(IOException e) {
            e.printStackTrace();
            if(!socket.isClosed()) {
                    excecuteErrorCGI(request, response, 
                            new HttpProtocolException(e.getMessage(), 
                                    HttpServer.INTERNAL_SERVER_ERROR));
            }
            setHandling(false);
            return;
        }

        String path = request.getPath();

        Hashtable requestMappingTable = config.getRequestMappingTable();
        Enumeration enumerationRequestURI = requestMappingTable.keys();
        
        CGI cgi = null;
        
        while(enumerationRequestURI.hasMoreElements()) {
            String requestURI = (String) enumerationRequestURI.nextElement();
            
            if(path.matches(requestURI)) {
                cgi = (CGI) requestMappingTable.get(requestURI);
                break;
            }
        }
        
        if(cgi == null) {
            cgi = (CGI) requestMappingTable.get(HttpServer.CONTENT_CGI_KEY);
        }
        
        assert request != null;
        assert response != null;
        assert cgi != null;

        try {
            setResponseHeader(response);
            cgi.excecute(request, response);
        } catch(HttpProtocolException e) {
            excecuteErrorCGI(request, response, e);
            setHandling(false);
            return;
        } catch(IOException e) {
            e.printStackTrace();
            if(!socket.isClosed()) {
                excecuteErrorCGI(request, response,
                        new HttpProtocolException(e.getMessage(),
                                HttpServer.INTERNAL_SERVER_ERROR));
            }
            setHandling(false);
            return;
        }
        
        if(!socket.isClosed()) {
            try {
                socket.close();
            } catch(IOException e) {
                e.printStackTrace();
                setHandling(false);
                return;
            }
        }
        
        setHandling(false);

        if(config.isDebug()) {
            printDebugMessage(request);
        }

    }
    
    private HttpRequest readRequest(Socket socket) throws HttpProtocolException, IOException {
        InetAddress address = socket.getInetAddress();
        InputStream in = null;
        
        try {
            in = socket.getInputStream();
        } catch(IOException e) {
            String message = "NGXg̓͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR, e);
        }
        
        this.inputStream = in;
        
        HttpRequestProcessor processor = HttpRequestProcessor.getProcessor();
        return processor.parseRequest(in, address);
    }
    
    private HttpResponse createResponse(Socket socket) throws HttpProtocolException {
        OutputStream out = null;
        
        try {
            out = socket.getOutputStream();
        } catch(IOException e) {
            String message = "NGXg̓͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR, e);
        }
        
        this.outputStream = null;
        
        HttpResponseProcessor processor = HttpResponseProcessor.getProcessor();
        return processor.createResponse(out);
    }
    
    private void setResponseHeader(HttpResponse response) throws HttpProtocolException {
        response.addHeader("Server", server);
        response.setDateHeader(date);
    }
    
    private void printDebugMessage(HttpRequest request) {
        StringBuffer debugMessage = new StringBuffer();
        
        String value = null;
        
        if((value = request.getHostAddress()) != null) {
            debugMessage.append(value + "<>");
        }
        if((value = new Date(date).toString()) != null) {
            debugMessage.append(value + "<>");
        }
        if((value = request.getMethod()) != null) {
            debugMessage.append(value + " ");
        }
        if((value = request.getFile()) != null) {
            debugMessage.append(value + " ");
        }
        if((value = request.getProtocolVersion()) != null) {
            debugMessage.append(value + "<>");
        }
        if((value = request.getHeader("Referer")) != null) {
            debugMessage.append(value + "<>");
        } else {
            debugMessage.append("<>");
        }
        if((value = request.getHeader("User-Agent")) != null) {
            debugMessage.append(value);
        }

        System.out.println(debugMessage.toString());
    }
   
    private void excecuteErrorCGI(HttpRequest request, HttpResponse response,
            HttpProtocolException exception) {
        response.setStatusCode(exception.getStatusCode());
        
        if(!socket.isClosed()) {
            try {
                (new ErrorCGI(exception)).excecute(request, response);
            } catch(HttpProtocolException e) {
                e.printStackTrace();
            } catch(IOException e) {
                e.printStackTrace();
            }
        }
       
    }
    
}
