/*
 * ListCGI.java
 *
 * Created on 2004/08/30, 22:07
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.File;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Date;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Enumeration;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.cgi.PlugIn;
import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.util.Time;
import net.sourceforge.shingetsu.util.RecordComparator;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.lang.NullPointerException;
import java.lang.NumberFormatException;
import java.security.NoSuchAlgorithmException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * CGIvOlist.cgiɑNXłB
 * @author stokesia
 */
public class ListCGI extends PlugIn {
    
    private Config config = Config.getInstance();
    private Hashtable typeTable = null;
    private Hashtable typeNameTable = null;
    private Comparator comparator = new RecordComparator();
    
    /** Creates a new instance of ListCGI */
    public ListCGI() {
        typeTable = new Hashtable();
        
        typeTable.put(super.TYPE_LIST, "list.cgi");
        typeTable.put(super.TYPE_NOTE, "note.cgi");
        typeTable.put(super.TYPE_THREAD, "thread.cgi");
        
        typeNameTable = new Hashtable();
        
        typeNameTable.put(super.TYPE_LIST, "Xg");
        typeNameTable.put(super.TYPE_NOTE, "m[g");
        typeNameTable.put(super.TYPE_THREAD, "Xbh");
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        String path = request.getPath();
        String command = request.getParameter("command");
        
        if(command == null) {
            if(path.matches("(^/list.cgi/?)")) {
                printMenuIndex(request, response, "menu");
            } else if(path.matches("^/list.cgi/.+")) {
                printMenuIndex(request, response, getName(path));
            } else {
                String message = "vꂽURL " + request.getPath() + " ͌܂łB";
                throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
            }
        } else if(command.equals("create")) {
            createFile(request, response);
	} else {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }

    }
    
    private void printMenuIndex(HttpRequest request, HttpResponse response, String menuName) 
        throws HttpProtocolException, IOException {
        String[] menuRecords = getMenuRecords(menuName);
        String filename = "list_" + toHexString(menuName);
        
        String fileLength =  null;
        
        try {
            long length = getCacheFile(TYPE_LIST, menuName).length();
            fileLength = getLengthByMB(length) + "MB";
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        PrintWriter writer = response.getWriter();
        
        super.printHeader(response, writer, menuName);
        super.printMenu(response, writer, menuName);
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"comfirm-delete\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />");
        writer.println("</p>");
        
        writer.println("<ul>");
        
        if(menuRecords != null) {
            for(int i = menuRecords.length - 1; i >= 0; i--) {
                writer.println(menuRecords[i]);
            }
        }
        
        writer.println("</ul>");
        
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"R[h폜\" tabindex=\"2\" accesskey=\"d\" />");
        //writer.println("<input type=\"hidden\" name=\"mode\" value=\"list\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        writer.println("<form method=\"post\" action=\"/list.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"create\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />");
        writer.println("<input type=\"submit\" value=\"VK쐬\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" />");
        writer.println("<input type=\"radio\" value=\"list\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />Xg ");
        writer.println("<input type=\"radio\" value=\"thread\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />Xbh ");
        writer.println("<input type=\"radio\" value=\"note\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />m[g ");
        writer.println("<input type=\"checkbox\" value=\"inform\" name=\"inform\" checked=\"checked\" tabindex=\"2\" accesskey=\"s\" />̃m[hɂʒm<br>");
        writer.println("O: <input name=\"name\" size=\"19\" value=\"\" tabindex=\"3\" accesskey=\"t\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        super.printDeleteFile(response, writer, filename);
        super.printFooter(response, writer);
    }
    
    private void printSignatureError(HttpResponse response, String title, String message)
        throws HttpProtocolException, IOException {
            
    }

    private String[] getMenuRecords(String menuName) throws HttpProtocolException, IOException {
        File listFile = null;
        
        try {
            listFile = getCacheFile(TYPE_LIST, menuName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] records = null;
        
        String[] tokens = listFile.getName().split("\\.");
        
        if(!listFile.exists()) {
            try {
                initCache(tokens[0]);
            } catch (IOException e) {
                String message = "LbVt@C̏ɓo̓G[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }
        
        if(listFile.exists()) {
            Cache cache = getCache(listFile);
            
            cache.lock();
            
            records = cache.getRecords();
            
            cache.unlock();
            cache.close();
            
            Vector recordList = createRecordList(records);
            
            records = createMenuRecords(recordList);
        }

        return records;
    }

    private String[] createMenuRecords(Vector recordList) throws HttpProtocolException  {
        int end = recordList.size();
        
        for(int index = 0; index < end; index++) {
            Hashtable record = (Hashtable) recordList.remove(0);
            
            record = createMenuRecord(record);
            record = createLinkRecord(record);
            
            recordList.add(record);
        }
        
        Object[] recordArray = recordList.toArray();
        Arrays.sort(recordArray, comparator);
        
        String[] records = new String[recordArray.length];

        for(int i = 0; i < records.length; i++) {
            Hashtable record = (Hashtable) recordArray[i];
            records[i] = (String) record.get(FIELD_NAME_BODY);
        }

        return records;
    }
    
    private Hashtable createMenuRecord(Hashtable record) throws HttpProtocolException {
        int nameGroup = 1;
        int valueGroup = 2;
        
        String body = (String) record.get(FIELD_NAME_BODY);
        
        String regex = "(" + FIELD_NAME_TYPE + "|" + FIELD_NAME_LINK + "):(.+)";
        Pattern pattern = Pattern.compile(regex);
        
        String[] tokens = body.split("<>");
        
        for(int i = 0; i < tokens.length; i++) {
            Matcher matcher = pattern.matcher(tokens[i]);
            
            if(matcher.matches()) {
                String name = matcher.group(nameGroup);
                String value = matcher.group(valueGroup);
                
                record.put(name, value);
            } else {
                continue;
                //String message = " ʎq " + id + " ̃R[h͏słB";
                //throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }
        
        return record;
    }
    
    private Hashtable createLinkRecord(Hashtable fieldTable) throws HttpProtocolException {
        String timeStamp = (String) fieldTable.get(FIELD_NAME_TIMESTAMP);
        String id = (String) fieldTable.get(FIELD_NAME_ID);
        String type = (String) fieldTable.get(FIELD_NAME_TYPE);
        String linkName = (String) fieldTable.get(FIELD_NAME_LINK);
        
        String recordTimeStamp = timeStamp;
        
        File file = null;

        try {
            file = getCacheFile(type, linkName);
        } catch(UnsupportedEncodingException e){
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String recordCount = "?";
        String fileLength = "0MB";

        if(file.exists()) {
            Cache cache = getCache(file);
            
            try {
                cache.lock();
                
                recordCount = Integer.toString(cache.getRecordCount());
                String record = cache.getLastRecord();
                
                cache.unlock();
                cache.close();
                
                if(record != null) {
                    Matcher matcher = Pattern.compile("^\\d+").matcher(record);
                    if(matcher.find()) {
                        timeStamp = matcher.group();
                    }
                }
            } catch(FileNotFoundException e) {
                String message = "Ŏw肳ꂽt@C "  + file.getName() + " ݂܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            } catch(IOException e) {
                String message = "t@C̓o͒ɃG[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
            fileLength = getLengthByMB(file.length()) + "MB";
        }
        
        long time = 0L;
        
        try {
          time = Long.parseLong(timeStamp) * 1000L;
        } catch(NumberFormatException e) {
            String message = "t@C " + file.getName() + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm");
        String date = dateFormat.format(new Date(time));
        
        String uri = null;

        try {
            uri = "/" + (String) typeTable.get(type) + "/" + encode(linkName);
        } catch(UnsupportedEncodingException e) {
            String message = "GR[fBOɎs܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String typeName = (String) typeNameTable.get(type);

        String record = "<li><input type=\"radio\" name=\"record\" value=\"" + recordTimeStamp  + "/" 
                                        + id +"\" tabindex=\"1\" accesskey=\"s\"/>"
                                        + date + ": <a href=\"" + uri + "\">" + linkName + "</a>"
                                        + "(" + typeName + "/" + recordCount + "/" + fileLength + ")"
                                        + "</li>";

        fieldTable.clear();
        
        fieldTable.put(FIELD_NAME_TIMESTAMP, timeStamp);
        fieldTable.put(FIELD_NAME_ID, id);
        fieldTable.put(FIELD_NAME_BODY, record);
        
        return fieldTable;
    }
    
    private void createFile(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        String name = request.getParameter("name");
        String type = request.getParameter("type");
        
        if((name == null) || (name.length() == 0)) {
            String message = "Ow肳Ă܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        if(type == null) {
            String message = "^Cvw肳Ă܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        long time = Time.getCurrentTime();
        String timeStamp = Long.toString(time);
        
        String body = "type:" + type + "<>link:" + name;
        String id = null;
        
        try {
            id = getMD5(body); 
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NoSuchAlgorithmException e) {
            String message = "w肳ꂽnbV֐̃ASY̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = timeStamp + "<>" + id + "<>" + body;
        
        String file = request.getParameter("file");
        
        File cacheFile = getCacheFile(file);
        Cache cache = getCache(cacheFile);
        
        try {
            cache.lock();
            
            cache.append(record);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "t@C " + cacheFile.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        try {
           cacheFile = getCacheFile(type, name);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } 
        
        try {
           cacheFile.createNewFile(); 
        } catch(IOException e) {
            String message = "t@C " + cacheFile.getName() + " ̍쐬Ɏs܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String encodedListName = null;
        
        try {
            String hexMenuName = detectBaename(file);
            String  menuName = toString(hexMenuName);
            
            encodedListName = encode(menuName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NumberFormatException e) {
            String message = "t@C " + cacheFile.getName() + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        response.addHeader("Location", "/list.cgi/" + encodedListName);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();
        
        long SLEEP_TIME = 3000L;
        String informing = request.getParameter("inform");
        
        if((informing != null) && informing.equals("inform")) {
            for(int i = 1; i <= config.getRetrySearchMax(); i++) {
                try {
                    String nodeAddress = getGlobalNodeAddress();
                    
                    if(nodeAddress != null) {
                        informUpdate(nodeAddress, time,file, id);
                        break;
                    }
                    
                    Thread.sleep(SLEEP_TIME);
                } catch(Exception e) {
                    e.printStackTrace();
                }
            }
        }

    }
    
    private Cache getCache(File file) throws HttpProtocolException {
        Cache cache = null;
        
        try {
            cache = new Cache(file);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return cache;
    }
    
 }
