/*
 * NoteCGI.java
 *
 * Created on 2004/10/04, 22:20
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.File;
import java.util.Vector;
import java.util.Arrays;
import java.util.Date;
import java.util.Comparator;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.Enumeration;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.node.NodeList;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.cgi.PlugIn;
import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.util.Time;
import net.sourceforge.shingetsu.util.RecordComparator;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.security.NoSuchAlgorithmException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * note.cgiɑCGIvÕNXłB
 * @author stokesia
 */
public class NoteCGI extends PlugIn {
    
    private Config config = Config.getInstance();
    private Comparator comparator = new RecordComparator();
    
    /** Creates a new instance of NoteCGI */
    public NoteCGI() {
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        String path = request.getPath();
        String command = request.getParameter("command");
        
        if(command == null) {
            if(path.matches("^/note.cgi/[^/]+")) {
                /*  regex pattern = ^/note.cgi/[^/]+  */
                printNoteRecord(request, response, getName(path));
            } else {
                String message = "vꂽURL " + request.getPath() + " ͌܂łB";
                throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
            }
        } else if(command.equals("append")) {
            appendNote(request, response);
        } else if(command.equals("post")) {
            postNote(request, response);
        } else if(command.equals("edit")) {
            printEditNote(request, response, getName(path));
        } else if(command.equals("history")) {
            printNoteHistory(request, response, getName(path));
        } else {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }

    }

    private Cache getCache(File file) throws HttpProtocolException {
        Cache cache = null;
        
	try {
            cache = new Cache(file);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return cache;
    }
    
    private void printNoteRecord(HttpRequest request, HttpResponse response, String noteName) 
        throws HttpProtocolException, IOException  {
        String noteRecord = getNoteRecord(noteName);
        Hashtable fieldTable = null;
        
        if(noteRecord != null) {
            fieldTable = createFieldTable(noteRecord);
        }
        
        String filename = null;
        String encodedName = null;
        
        try {
            filename = TYPE_NOTE + "_" + toHexString(noteName);
            encodedName = encode(noteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        long length = getLengthByMB(getCacheFile(TYPE_NOTE, noteName).length());
        String fileLength = Long.toString(length) + "MB";

        String body = "";
        
        if(fieldTable != null) {
            body = (String) fieldTable.get(FIELD_NAME_BODY);
            
            try {
                body = createLink(body);
                body = createBracketLink(body);
            } catch(UnsupportedEncodingException e) {
                String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }
        
        PrintWriter writer = response.getWriter();
        
        super.printHeader(response, writer,noteName);
        super.printMenu(response, writer, noteName);
        
        writer.println("<p>" + body + "</p>");
        
        writer.println("<form method=\"post\" action=\"/note.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"append\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" +filename + "\" />");
        writer.println("<input type=\"submit\" value=\"ǉ\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" /> ");
        writer.println("<input type=\"checkbox\" value=inform\" name=\"inform\" checked=\"checked\" tabindex=\"2\" accesskey=\"s\" />̃m[hɂʒm ");
        writer.println("<input type=\"checkbox\" value=\"error\" name=\"error\" checked=\"checked\" tabindex=\"2\" accesskey=\"e\" />ݎɌ덷<br/>");
        writer.println("<textarea rows=\"5\" cols=\"70\" name=\"message\" tabindex=\"8\" accesskey=\"c\"></textarea><br>");
        writer.println("<a href=\"/note.cgi/" + encodedName + "?command=edit\">ҏW</a> | ");
        writer.println("<a href=\"/note.cgi/" + encodedName + "?command=history\"></a>");
        writer.println("</p>");
        writer.println("</form>");

        super.printDeleteFile(response, writer, filename);
        super.printFooter(response, writer);
    }

    private void printEditNote(HttpRequest request, HttpResponse response,String noteName) 
        throws HttpProtocolException, IOException  {
        String noteRecord = getNoteRecord(noteName);
        Hashtable fieldTable = createFieldTable(noteRecord);
        
        String filename = null;
        String fileLength =  null;
        
        try {
            filename = TYPE_NOTE + "_" + toHexString(noteName);
            long length = getCacheFile(TYPE_NOTE, noteName).length();
            fileLength = getLengthByMB(length) + "MB";
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String timeStamp = (String) fieldTable.get(FIELD_NAME_TIMESTAMP);
        String id = (String) fieldTable.get(FIELD_NAME_ID);
        String body = (String) fieldTable.get(FIELD_NAME_BODY);
        
        try {
            body = createLink(body);
            body = createBracketLink(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String editBody = unescape(body);
        
        PrintWriter writer = response.getWriter();
        
        super.printHeader(response, writer,noteName);
        super.printMenu(response, writer, noteName);
        
        writer.println("<p>" + body + "</p>");
        
        writer.println("<form method=\"post\" action=\"/note.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"post\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" +filename + "\" />");
        writer.println("<input type=\"submit\" value=\"e\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" /> ");
        writer.println("<input type=\"checkbox\" value=inform\" name=\"inform\" checked=\"checked\" tabindex=\"2\" accesskey=\"s\" />̃m[hɂʒm ");
        writer.println("<input type=\"checkbox\" value=\"error\" name=\"error\" checked=\"checked\" tabindex=\"2\" accesskey=\"e\" />ݎɌ덷<br/>");
        writer.println("<textarea rows=\"20\" cols=\"75\" name=\"message\" tabindex=\"8\" accesskey=\"c\">");
        writer.println(editBody);
        writer.println("</textarea>");
        writer.println("<input type=\"hidden\" value=\"" + timeStamp + "\" name=\"base_stamp\" />");
        writer.println("<input type=\"hidden\" value=\"" + id + "\" name=\"base_id\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        super.printDeleteFile(response, writer, filename);
        super.printFooter(response, writer);
    }
    
    private void appendNote(HttpRequest request, HttpResponse response)
        throws HttpProtocolException, IOException  {
        String file = request.getParameter("file");
        String body = request.getParameter("message");
        String error = request.getParameter("error");
        
        if((body == null) || (body.length() == 0)) {
            String message = "bZ[W͂Ă܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        long time = 0L;
        
        if((error != null) && error.equals("error")) {
            time = Time.getCurrentFuzzyTime();
        } else {
            time = Time.getCurrentTime();
        }

        String timeStamp = Long.toString(time);
        
        String noteName = null;

        try {
            String hexNoteName = detectBaename(file);
            noteName = toString(hexNoteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String noteRecord = getNoteRecord(noteName);
        Hashtable fieldTable = createFieldTable(noteRecord);
        
        String baseStamp = (String) fieldTable.get(FIELD_NAME_BASE_STAMP);
        String baseID = (String) fieldTable.get(FIELD_NAME_ID);
        String baseBody = (String) fieldTable.get(FIELD_NAME_BODY);
        
        body = baseBody + "<br><br>" + escape(body);
        body = "body:" + body + "<>" + "base_stamp:" + baseStamp + "<>" + "base_id:" + baseID;
        
        String id = null;
        
        try {
            id = getMD5(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NoSuchAlgorithmException e) {
            String message = "w肳ꂽnbV֐̃ASY̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = timeStamp + "<>" + id + "<>" + body;

        File cacheFile = getCacheFile(file);  
        Cache cache = getCache(cacheFile);
        
        try {
            cache.lock();
            
            cache.append(record);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + cacheFile.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
    
        String encodedNoteName = null;
        
        try {
            encodedNoteName = encode(noteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        response.addHeader("Location", "/note.cgi/" + encodedNoteName);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();

        long SLEEP_TIME = 3000L;
        String informing = request.getParameter("inform");

        if((informing != null) && informing.equals("inform")) {
            for(int i = 1; i <= config.getRetrySearchMax(); i++) {
                try {
                    String nodeAddress = getGlobalNodeAddress();
                    
                    if(nodeAddress != null) {
                        informUpdate(nodeAddress, time, file, id);
                        break;
                    }
                    
                    Thread.sleep(SLEEP_TIME);
                } catch(Exception e) {
                    e.printStackTrace();
                }
            }
        }

    }
    
    private void postNote(HttpRequest request, HttpResponse response)
        throws HttpProtocolException, IOException  {
        String file = request.getParameter("file");
        String body = request.getParameter("message");
        String error = request.getParameter("error");
        
        if((body == null) || (body.length() == 0)) {
            String message = "bZ[W͂Ă܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String baseStamp = request.getParameter("base_stamp");
        String baseID = request.getParameter("base_id");

        long time = 0L;
        
        if((error != null) && error.equals("error")) {
            time = Time.getCurrentFuzzyTime();
        } else {
            time = Time.getCurrentTime();
        }
        
        String timeStamp = Long.toString(time);
        
        String noteName = null;

        try {
            String hexNoteName = detectBaename(file);
            noteName = toString(hexNoteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        body = "body:" + escape(body) + "<>" + "base_stamp:" + baseStamp + "<>" + "base_id:" + baseID;
        
        String id = null;
        
        try {
            id = getMD5(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NoSuchAlgorithmException e) {
            String message = "w肳ꂽnbV֐̃ASY̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = timeStamp + "<>" + id + "<>" + body;

        File cacheFile = getCacheFile(file);
        Cache cache = getCache(cacheFile);
        
        try {
            cache.lock();
            
            cache.append(record);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + cacheFile.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
    
        String encodedNoteName = null;
        
        try {
            encodedNoteName = encode(noteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        response.addHeader("Location", "/note.cgi/" + encodedNoteName);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();

        long SLEEP_TIME = 3000L;
        String informing = request.getParameter("inform");

        if((informing != null) && informing.equals("inform")) {
            for(int i = 1; i <= config.getRetrySearchMax(); i++) {
                try {
                    String nodeAddress = getGlobalNodeAddress();
                    
                    if(nodeAddress != null) {
                        informUpdate(nodeAddress, time, file, id);
                        break;
                    }
                    
                    Thread.sleep(SLEEP_TIME);
                } catch(Exception e) {
                    e.printStackTrace();
                }
            }
        }

    }
    
    private void printNoteHistory(HttpRequest request, HttpResponse response, String noteName)
        throws HttpProtocolException, IOException  {
        String[] noteRecords = getThreadRecords(noteName);
        
        String filename = null;
        String fileLength =  null;
        
        try {
            filename = TYPE_NOTE + "_" + toHexString(noteName);
            long length = getCacheFile(filename).length();
            fileLength = getLengthByMB(length) + "MB";
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String noteRecord = getNoteRecord(noteName);
        Hashtable fieldTable = createFieldTable(noteRecord);

        String timeStamp = (String) fieldTable.get(FIELD_NAME_TIMESTAMP);
        String id = (String) fieldTable.get(FIELD_NAME_ID);
        String body = (String) fieldTable.get(FIELD_NAME_BODY);
        
        String editBody = unescape(body);

        PrintWriter writer = response.getWriter();
        
        super.printHeader(response, writer, noteName);
        super.printMenu(response, writer, noteName);
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"comfirm-delete\"  />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />");
        writer.println("</p>");
        
        writer.println("<dl>");
        
        if(noteRecords != null) {
            for(int i = 0; i < noteRecords.length; i++) {
                writer.println(noteRecords[i]);
            }
        }
        
        writer.println("</dl>");
        
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"R[h폜\" tabindex=\"2\" accesskey=\"d\" />");
        //writer.println("<input type=\"hidden\" name=\"mode\" value=\"thread\" />");
        writer.println("</p>");
        writer.println("</form>");

        writer.println("<form method=\"post\" action=\"/note.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"post\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" +filename + "\" />");
        writer.println("<input type=\"submit\" value=\"e\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" /> ");
        writer.println("<input type=\"checkbox\" value=inform\" name=\"inform\" checked=\"checked\" tabindex=\"2\" accesskey=\"s\" />̃m[hɂʒm ");
        writer.println("<input type=\"checkbox\" value=\"error\" name=\"error\" checked=\"checked\" tabindex=\"2\" accesskey=\"e\" />ݎɌ덷<br/>");
        writer.println("<textarea rows=\"20\" cols=\"75\" name=\"message\" tabindex=\"8\" accesskey=\"c\">");
        writer.println(editBody);
        writer.println("</textarea>");
        writer.println("<input type=\"hidden\" value=\"" + timeStamp + "\" name=\"base_stamp\" />");
        writer.println("<input type=\"hidden\" value=\"" + id + "\" name=\"base_id\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        super.printDeleteFile(response, writer, filename);
        super.printFooter(response, writer);
    }
    
    private String getNoteRecord(String noteName) throws HttpProtocolException {
        File noteFile = null;
        
        try {
            noteFile = getCacheFile(TYPE_NOTE, noteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] tokens = noteFile.getName().split("\\.");
        
        if(!noteFile.exists()) {
            try {
                initCache(tokens[0]);
            } catch (IOException e) {
                String message = "LbVt@C̏ɓo̓G[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }

        Cache noteCache = getCache(noteFile);
        
        String[] records = null;
        
        try {
            noteCache.lock();
            
            records = noteCache.getRecords();
            
            noteCache.unlock();
            noteCache.close();
        } catch(FileNotFoundException e) {
            String message = "t@C "  + noteFile.getName() + " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = null;
        
        if(records != null) {
            for(int i = records.length - 1; i >= 0; i--) {
                if(!isRemoveRecord(records[i])) {
                    record = records[i];
                    break;
                }
            }
        }
        
        return record;
    }
    
    private String[] getThreadRecords(String noteName) throws HttpProtocolException {
        File noteFile = null;
        
        try {
            noteFile = getCacheFile(TYPE_NOTE, noteName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] tokens = noteFile.getName().split("\\.");
        
        if(!noteFile.exists()) {
            try {
                initCache(tokens[0]);
            } catch (IOException e) {
                String message = "LbVt@C̏ɓo̓G[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }

        Cache noteCache = getCache(noteFile);
        
        String[] records = null;

        try {
            noteCache.lock();
            
            records = noteCache.getRecords();
            
            noteCache.unlock();
            noteCache.close();
        } catch(FileNotFoundException e) {
            String message = "t@C "  + noteFile.getName() + " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        Vector recordList = createRecordList(records);
        records = createThreadRecords(recordList);

        return records;
    }
    
    private String[] createThreadRecords(Vector recordList) throws HttpProtocolException {
        int end = recordList.size();
        
        for(int index = 0; index < end; index++) {
            Hashtable record = (Hashtable) recordList.remove(0);
            
            Hashtable fieldTable = createFieldTable(record);
            record = createMessageRecord(fieldTable);
            
            recordList.add(record);
        }
        
        Object[] recordArray = recordList.toArray();
        Arrays.sort(recordArray, comparator);
        
        String[] records = new String[recordArray.length];

        for(int i = 0; i < records.length; i++) {
            Hashtable record = (Hashtable) recordArray[i];
            records[i] = (String) record.get(FIELD_NAME_BODY);
        }

        return records;
    }

    private Hashtable createFieldTable(String record) {
        String[] records = new String[1];
        records[0] = record;
        
        Vector recordList = createRecordList(records);
        Hashtable fieldTable = createFieldTable((Hashtable) recordList.get(0));
        
        return fieldTable;
    }
    
    private Hashtable createFieldTable(Hashtable record) {
        int nameGroup = 1;
        int valueGroup = 2;
        
        String body = (String) record.get(FIELD_NAME_BODY);

        String regex = "(" + FIELD_NAME_BODY + "|" + FIELD_NAME_BASE_ID
                                    + "|" + FIELD_NAME_BASE_STAMP +"):(.+)";
                                    
        Pattern pattern = Pattern.compile(regex);
        
        String[] tokens = body.split("<>");
        
        for(int i = 0; i < tokens.length; i++) {
            Matcher matcher = pattern.matcher(tokens[i]);
            
            if(matcher.matches()) {
                String name = matcher.group(nameGroup);
                String value = matcher.group(valueGroup);
                
                record.put(name, value);
            } else {
                continue;
                //String message = " ʎq " + id + " ̃R[h͏słB";
                //throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }
        
        return record;
    }
    
    private Hashtable createMessageRecord(Hashtable fieldTable) throws HttpProtocolException {
        String timeStamp = (String) fieldTable.get(FIELD_NAME_TIMESTAMP);
    
        String baseId = null;
        
        if(fieldTable.containsKey(FIELD_NAME_BASE_ID)) {
            baseId = (String) fieldTable.get(FIELD_NAME_BASE_ID);
        } else {
            baseId = "";
        }

        String id = (String) fieldTable.get(FIELD_NAME_ID);
        
        String anchor = id.substring(0, 8);
        String baseAnchor = null;
        
        if(baseId.length() != 0) {
            baseAnchor = baseId.substring(0, 8);
        } else {
            baseAnchor = "";
        }
        
        String body = (String) fieldTable.get(FIELD_NAME_BODY);
        
        long time = 0;
        
        try {
          time = Long.parseLong(timeStamp) * 1000L;
        } catch(NumberFormatException e) {
            String message = "ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm");
        String date = dateFormat.format(new Date(time));
        
        body = createLink(body);
        
        try {
            body = createBracketLink(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String record = "<dt id=\"r" + anchor + "\">" + "<input type=\"radio\" name=\"record\" "
                                        + "value=\"" + timeStamp + "/" + id +"\" tabindex=\"1\" accesskey=\"s\"/>"
                                        + anchor + " " + date + " " + "<a href=\"#r" + baseAnchor + "\">"
                                        + "(&gt;&gt;" + baseAnchor + "</a></dt>" 
                                        + "<dd>" + body + "<br><br></dd>";

        fieldTable.clear();
        
        fieldTable.put(FIELD_NAME_TIMESTAMP, timeStamp);
        fieldTable.put(FIELD_NAME_ID, id);
        fieldTable.put(FIELD_NAME_BODY, record);
        
        return fieldTable;
    }
 
}
