/*
 * Config.java
 *
 * Created on 2004/06/17, 22:22
 */
package net.sourceforge.shingetsu.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.FileReader;
import java.lang.Integer;
import java.lang.Boolean;
import java.lang.ClassLoader;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Properties;
import java.util.Hashtable;

import net.sourceforge.shingetsu.io.MultipleLineReader;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.cgi.ContentCGI;
import net.sourceforge.shingetsu.server.cgi.CGI;
import net.sourceforge.shingetsu.server.cgi.CGIClassLoader;

import java.lang.SecurityException;
import java.lang.ClassNotFoundException;
import java.net.MalformedURLException;
import java.io.IOException;
import java.io.FileNotFoundException;

/**
 * V̐ݒ\NXłBftHg̐ݒ͂̃NXŒ`Ă܂B
 * ̃ftHglύXɂ͐V̐ݒt@CҏW܂B
 * @author Fuktommy
 * @author stokesia
 */
public class Config {
    
    /**
     * V̐ݒvpeBt@Cւ̃pXłB
     */    
    public static final String SHINGETSU_PROPERTIES = "file/shingetsu.properties";
    
    private static Config config = new Config();
    
    private Hashtable configTable = null;
    
    /**
     * constructor.
     * @param path path of config file
     */
    private Config() {
        configTable = new Hashtable();
        
        setDefaultValue();

//        Properties properties = new Properties();
//        
//        try {
//            properties.load(new FileInputStream(new File(Config.SHINGETSU_PROPERTIES)));
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//        
//        Enumeration enumeration = properties.keys();
//        
//        while(enumeration.hasMoreElements()) {
//            String key = (String) enumeration.nextElement();
//            String property = (String) properties.getProperty(key);
//            
//            if((key != null) && (property != null)) {
//                configTable.put(key, property);
//            }
//        }
//
//        setToLowerCase();
//        
    }
    
    private void setDefaultValue() {
        configTable.put("GeneralEncoding", "UTF-8");
        configTable.put("ShinGETsuVersion", "0.5.2");
        configTable.put("SeleneVersion", "0.1.0-beta5");
        
        configTable.put("Port", "8000");
        configTable.put("StartServerThread", "10");
        configTable.put("MaxServerThread", "25");
        configTable.put("Backlog", "50");
        configTable.put("NodeSize", "10");
        
        configTable.put("InitNodes", "fuktommy.ddo.jp/server.cgi");
        
        configTable.put("DataDirectory", "dat");
        configTable.put("DataFileExtension", "dat");
        configTable.put("FileDirectory", "file");
        configTable.put("DocumentRootDirectory", "htdocs");
        
        configTable.put("MotdFilename", "motd.txt");
        configTable.put("NodeFilename", "node.txt");
        configTable.put("UpdateFilename", "update.txt");
        configTable.put("StatusFilename", "stat.txt");
        
        configTable.put("PingCycle", "10");
        configTable.put("SyncCycle", "60");
        configTable.put("InitCycle", "25");
        
        configTable.put("ClientSleepTime", "8");
        
        configTable.put("RetrySearchMax", "3");
        configTable.put("RetryGetMax", "3");

        configTable.put("SaveUpdate", "1440");
        configTable.put("SyncSafety", "240");
        
        configTable.put("TimeErrorRange", "60");

        configTable.put("CheckMD5", "true");
        configTable.put("AdminHostAddress", "^127.0.0.1");
        
        configTable.put("RequestBufferSize", "2048");
        configTable.put("ResponseBufferSize", "512");
        configTable.put("BufferSize", "2048");
        configTable.put("Debug", "true");
    }
    
    private void setToLowerCase() {
        Enumeration enumerationKey = configTable.keys();
        
        while(enumerationKey.hasMoreElements()) {
            String key = (String) enumerationKey.nextElement();
            String value = (String) configTable.get(key);
            configTable.remove(key);
            
            configTable.put(key.toLowerCase(), value);
        }
    }

    private Object get(String key) {
        return configTable.get(key.toLowerCase());
    }
    
    /**
     * VgpGR[fBOԂ܂B̃vpeB͒ʏύXׂ
     * ł͂܂B
     * @return VgpGR[fBO
     */
    public String getGeneralEncoding() {
        return "UTF-8";
    }

    /**
     * ̃T[og̐ڑ󂯕t|[gԂ܂B
     * @return |[gԍ
     */    
    public int getPort() {
        int port = 8000;
        
        try {
            port = Integer.parseInt((String) get("Port"));
        } catch(NumberFormatException e) {
            System.out.println("|[gԍsłB");
        }
        
        return port;
    }
    
    /**
     * Młőڑ擾܂B
     * @return obNO
     */    
    public int getBacklog() {
        int backlog = 50; /*    The default value of backlog is 50. */
        
        try {
            backlog = Integer.parseInt((String) get("Backlog"));
        } catch(NumberFormatException e) {
            System.out.println("obNOsłB");
        }
        
        return backlog;
    }
    
    /**
     * 邱ƂłT[õXbh̐擾܂B
     * @return T[oXbh̍ő吔
     */    
    public int getMaxServerThread() {
        int maxServerThread = 25; 
        
        try {
            maxServerThread = Integer.parseInt((String) get("MaxServerThread"));
        } catch(NumberFormatException e) {
            System.out.println("T[oXbh̍ő吔̎w肪słB");
        }
        
        return maxServerThread;
    }
    
    /**
     * N̐VT[õXbh̐擾܂B
     * @return ÑT[oXbh
     */    
    public int getStartServerThread() {
        int startServerThread = 15; 
        
        try {
            startServerThread = Integer.parseInt((String) get("StartServerThread"));
        } catch(NumberFormatException e) {
            System.out.println("ÑT[oXbh̎w肪słB");
        }
        
        return startServerThread;
    }
    
    /**
     * Ṽo[WԂ܂B
     * @return Ṽo[W
     */
    public String getShinGETsuVersion() {
        return (String) get("ShinGETsuVersion");
    }
    
    /**
     * Selenẽo[WԂ܂B
     * @return Selenẽo[W
     */
    public String getSeleneVersion() {
        return (String) get("SeleneVersion");
    }
    
    /**
     * [UG[WFgԂ܂B
     * @return [UG[WFg
     */
    public String getUserAgent() {
        String shinGETsuVersion = config.getShinGETsuVersion();
        String seleneVersion = config.getSeleneVersion();
    
        String userAgent = "ShinGETsu/" + shinGETsuVersion + " (Selene/" + seleneVersion + ")";
        
        return userAgent;
    }
    
    /**
     * Message of the diaryt@C擾܂B
     * @return Message of the diaryt@C
     */    
    public String getMotdFilename() {
        return (String) get("MotdFilename");
    }
    
    /**
     * m[hLqĂt@C擾܂B
     * @return m[h̃t@C
     */
    public String getNodeFilename() {
        return (String) get("NodeFilename");
    }
    
    /**
     * JHTMLt@CzuĂfBNg擾܂B
     * @return HTMLt@CzuĂfBNg
     */
    public String getDocumentRootDirectory() {
        return (String) get("DocumentRootDirectory");
    }
    
    /*
    public String getUpdateFilename() {
        return updateFilename;
    }
     */
    
    /*
    public String getStatusFilename() {
        return statusFilename;
    }
     */

    /**
     * f[^t@C̃fBNg擾܂B
     * @return  f[^fBNg
     */
    public String getDataDirectory() {
        return "dat";
        //return (String) get("DataDirectory");
    }
    
    /**
     * f[^t@C̊gq擾܂B
     * @return  f[^t@C̊gq
     */
    public String getDataFileExtension() {
        return (String) get("DataFileExtension");
    }
    
    /**
     * t@Ci[ĂfBNg擾܂B
     * @return t@Ci[ĂfBNg
     */    
    public String getFileDirectory() {
        return (String) get("FileDirectory");
    }
    
    /**
     * s񐔎擾܂B
     * @return s
     */    
    public int getRetrySearchMax() {
        int retrySearchMax = 3;
        
        try {
            retrySearchMax = Integer.parseInt((String) get("RetrySearchMax"));
        } catch(NumberFormatException e) {
            System.out.println("s񐔂̎w肪słB");
        }
        
        return retrySearchMax;
    }
    
    /**
     * 擾s񐔂擾܂B
     * @return 擾s
     */    
    public int getRetryGetMax() {
        int retryGetMax = 3;
        
        try {
            retryGetMax = Integer.parseInt((String) get("RetryGetMax"));
        } catch(NumberFormatException e) {
            System.out.println("擾s񐔂̎w肪słB");
        }
        
        return retryGetMax;
    }

    /**
     * V̐ݒvpeBt@CɎw肳Ă鏉m[h擾܂B
     * @return m[h̔z
     */    
    public int getNodeSize() {
        int nodeSize = 10;
        
        try {
            nodeSize = Integer.parseInt((String) get("NodeSize"));
        } catch(NumberFormatException e) {
            System.out.println("ێm[h̎w肪słB");
        }
        
        return nodeSize;
    }
    
    /*
    public int getSyncSafety() {
        return syncSafety;
    }
     */
    
    /*
    public int getSaveUpdate() {
        return saveUpdate;
    }
     */
    
    /**
     * QƂĂm[hLǂmF邽߂PingԊu擾܂B
     * @return ping̕Ԋu
     */
    public int getPingCycle() {
        int pingCycle = 10;
        
        try {
            pingCycle = Integer.parseInt((String) get("PingCycle"));
        } catch(NumberFormatException e) {
            System.out.println("PingԊu̎w肪słB");
        }
        
        return pingCycle;
    }

    /**
     * lbg[ÑLbVt@Cƃ[J̃LbVt@C̓Ƃ
     * uw肵܂B
     * @return LbVԊuBPʂ͕B
     */    
      public int getSyncCycle() {
        int syncCycle = 60;
        
        try {
            syncCycle = Integer.parseInt((String) get("SyncCycle"));
        } catch(NumberFormatException e) {
            System.out.println("LbVԊu̎w肪słB");
        }
        
        return syncCycle;
    }
    
      /**
       * m[hԊu擾܂B
       * @return ԊuBPʂ͕B
       */      
    public int getInitCycle() {
        int initCycle = 25;
        
        try {
            initCycle = Integer.parseInt((String) get("InitCycle"));
        } catch(NumberFormatException e) {
            System.out.println("Ԋu̎w肪słB");
        }
        
        return initCycle;
    }
    
      /**
       * NCAgXbh̃X[v^C擾܂B
       * @return NCAgXbh̃X[v^CBPʂ͕B
       */      
    public int getClientSleepTime() {
        int clientSleepTime = 8;
        
        try {
            clientSleepTime = Integer.parseInt((String) get("ClientSleepTime"));
        } catch(NumberFormatException e) {
            System.out.println("NCAgXbh̃X[v^C̎w肪słB");
        }
        
        return clientSleepTime;
    }
    
    /**
     * ݒ肳Ă錻ݎɑ΂Ă̌덷bŕԂ܂B
     * @return 덷̎(Pʂ͕b)
     */
    public int getTimeErrorRange() {
        int timeErrorRange = 60;
        
        try {
            timeErrorRange = Integer.parseInt((String) get("TimeErrorRange"));
        } catch(NumberFormatException e) {
            System.out.println("Ԍ덷̎w肪słB");
        }
        
        return timeErrorRange;
    }
    
    /**
     * @MD5l`FbN邩ǂԂ܂B
     * @return `FbN̂łtrue
     */    
    public boolean isCheckMD5() {
        boolean checkMD5 = true;

        checkMD5 = (Boolean.valueOf((String) get("CheckMD5"))).booleanValue();

        return checkMD5;
    }
    
    /**
     * VǗłzXgIPAhX̐K\p^[擾܂B
     * @return zXgIPAhX̐K\p^[
     */    
    public String getAdminHostAddress() {
        return (String) get("AdminHostAddress");
    }
    
    /**
     * fobO[hɐݒ肳Ă邩ǂԂ܂B
     * @return fobO[hɐݒ肳Ătrue
     */    
    public boolean isDebug() {
        boolean debug = true;
        
        debug = (Boolean.valueOf((String) get("Debug"))).booleanValue();
        
        return debug;
    }
    
    /**
     * NGXgňxɓǂݍރobt@̃TCYw肵܂BftHg
     * 2048oCgłB
     * @return NGXg̃obt@TCY
     */    
    public int getRequestBufferSize() {
        int requestBufferSize = 2048;

        try {
            requestBufferSize = Integer.parseInt((String) get("RequestBufferSize"));
        } catch(NumberFormatException e) {
            System.out.println("obt@̎w肪słB");
        }
        
        return requestBufferSize;
    }
    
    /**
     * X|Xňxɑoobt@̃TCYw肵܂BftHg
     * 512oCgłB
     * @return X|X̃obt@TCY
     */    
    public int getResponseBufferSize() {
        int responseBufferSize = 512;

        try {
            responseBufferSize = Integer.parseInt((String) get("responseBufferSize"));
        } catch(NumberFormatException e) {
            System.out.println("X|Xobt@̎w肪słB");
        }
        
        return responseBufferSize;
    }
    
    /**
     * [J̃oCit@Cǂݍނ߂̃obt@TCYԂ܂BftHg
     * 2048oCgłB
     * @return obt@TCY
     */    
    public int getBufferSize() {
        int bufferSize = 2048;
        
        try {
            bufferSize = Integer.parseInt((String) get("BufferSize"));
        } catch(NumberFormatException e) {
            System.out.println("NGXgobt@̎w肪słB");
        }
        
        return bufferSize;
    }
    
    /**
     * @HashtableNX̃IuWFNgŕ\ꂽNGXg̃}bsOe[uԂ
     * ܂BNGXgɑΉIuWFNg擾ɂ́AL[ƂăNGXgp^[
     * ̐K\L[ƂĎw肵܂B
     * @return NGXg̃}bsOi[ꂽHashtableNX̃IuWFNg
     * @throws SecurityException ZLeB}l[W݂A checkCreateClassLoader \bhVN
     * X[_̍쐬Ȃꍇ
     */    
    public Hashtable getRequestMappingTable() throws SecurityException {
        boolean resolve = true;
        CGI cgi = null;
        CGIClassLoader loader = new CGIClassLoader(getClass().getClassLoader());
        
        Hashtable requestMappingTable =new Hashtable();
        
        String line = (String) get("RequestMappingTable");
        String[] mappings = line.split("\\s+");
        
        for(int i = 0; i < mappings.length; i += 2) {
            if((i + 1) < mappings.length) {
                String uriPattern = mappings[i];
                String className = mappings[i + 1];
                
                try {
                    cgi=  (CGI) loader.loadClass(className, resolve).newInstance();
                } catch(ClassNotFoundException e) {
                    System.err.println(className + "NX܂B");
                    e.printStackTrace();
                    continue;
                } catch(InstantiationException e) {
                    System.err.println(className + "NX̃CX^Xł܂B");
                    e.printStackTrace();
                    continue;
                } catch(IllegalAccessException e) {
                    System.err.println(className + "NX܂͂nullRXgN^ɃANZXł܂B");
                    e.printStackTrace();
                    continue;
                }
                
                requestMappingTable.put(uriPattern, cgi);
            }
        }
        
        requestMappingTable.put(HttpServer.CONTENT_CGI_KEY, new ContentCGI());
        
        return requestMappingTable;
    }
    
    /**
     * fBÃ}bsOe[u擾܂Be[ũL[̓t@C̊gqŁA
     * 擾L[w肵ĒlɃANZX܂B
     * @return HashtableNX̃IuWFNg̃fBA^Cṽe[u
     */    
    public Hashtable getMediaTypeMappingTable() {
        Hashtable mediaTypeMappingTable =new Hashtable();
        
        String line = (String) get("MediaTypeMappingTable");
        String[] mappings = line.split("\\s+");
        
        for(int i = 0; i < mappings.length; i += 2) {
            if((i + 1) < mappings.length) {
                String contentType = mappings[i];
                String mediaType = mappings[i + 1];                
                mediaTypeMappingTable.put(contentType, mediaType);
            }
        }
        
        return mediaTypeMappingTable;
    }
    
    /**
     * V̐ݒt@CŎw肳Ă鏉m[h̔zԂ܂B
     * @return m[h̔z
     */
    public Node[] getInitNodes() {
        String line = (String) get("InitNodes");
        String[] nodes = line.split("\\s+");
        
        Vector initNodeList = new Vector();
        
        for(int i = 0; i < nodes.length; i++) {
            initNodeList.add(nodes[i].trim());
        }
        
        Vector checkedInitNodeList = new Vector();
        
        Enumeration enumeration = initNodeList.elements();
        
        while(enumeration.hasMoreElements()) {
            try {
                checkedInitNodeList.add(new Node((String) enumeration.nextElement()));
            } catch(MalformedURLException e) {
                System.out.println((String) enumeration.nextElement() + ":ȃm[hAhXłB");
                e.printStackTrace();
            }
        }
        
        enumeration = checkedInitNodeList.elements();
        Node[] initNodes = new Node[checkedInitNodeList.size()];
        
        for(int i = 0; enumeration.hasMoreElements(); i++) {
            initNodes[i] = (Node) enumeration.nextElement();
        }
        
        return initNodes;
    }
    
    /**
     * V̐ݒIuWFNg擾܂B
     * @return ݒIuWFNg
     */
    public static Config getInstance() {
        return config;
    }
    
}
